// Lawson Labs, Inc.
// 3217 Phoenixville Pike
// Malvern, PA  19355
// 800 321-5355 or 610 725-8800             
// Converted 16-bit to 32-bit 6-3-99
// Programmer (32-bit) - Tim Van Dusen 
// filename: NT_m202a



#include <windows.h>
#include <stdio.h>
#include <dos.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>
#include <ctype.h>
#include <string.h>
#include <time.h>
#include "NT_m202a.h"





//=============================================================================
//==== MAIN FUNCTION ==========================================================
//=============================================================================
int __cdecl main(void)
{
	pM202 = &M202;
	pNewScanBuff = NewScanBuff;
	FILE		*out;

	long		rawCount, scanCnt;
	int		i,n,p_row = 14,logging, startCC, endCC, ccode, Ch;
	double	voltage, max=-12000, min=12000, dacAvolts, dacBvolts;
	char		fileName[12], tmpbuf[80];;
	short		receiveError, localAvg=1, checkSum = 1;
	short		cc[6], tempCh, tempSub;
	short		bauds[]={  //  table for baud rate codes
								/* 0 */  9600,
								/* 1 */  4800,
								/* 2 */  2400,
								/* 3 */  1200,
								/* 4 */   600,
								/* 5 */   300};
	//variables for standard deviation calculation
	double	stDv=0, rmsBits=0, sdTot = 0, runningAvg=0, sd[41];;
	int	sdCount=1;

	hOutCon = GetStdHandle(STD_OUTPUT_HANDLE);
	if(!hOutCon)
	{
		MessageBox(0, "Error writing to console", "-- error", MB_OK);
		return 1;
	}
	hInCon =  GetStdHandle(STD_INPUT_HANDLE);
	if(!hInCon)
	{
		MessageBox(0, "Error reading from console", "-- error", MB_OK);
		return 1;
	}

	ConsoleCursorInfo.dwSize=1;
	ConsoleCursorInfo.bVisible = TRUE;

	if(!LoadLibraries())
		exit(1);

	if(!CheckLibFuncs())
	{
		UnloadLibraries();
		exit(1);
	}

	if (!ReadConfig(&localAvg))
	{
	  gotoxy(24,10);
	  printf("unable to read 201EWIN.CFG file");
	  gotoxy(26,11);
	  printf("press any key to continue");
	  getch();
	}

	if(!SetPtrs(pM202, pNewScanBuff))
	{
		MessageBox(0, "Could not set required pointers\n"
					"  between application and DLL", "-- error", MB_OK);
		UnloadLibraries();
		exit(1);
	}

	if (!ReadConfig(&localAvg))
	{
	gotoxy(24,10);
	printf("unable to read 202EWIN.CFG file");
	gotoxy(26,11);
	printf("press any key to continue");
	getch();
	}

	M202.standBy = 0;						//set to not in standby



TOP_MENU:

	Ch = 0;

	while(Ch != 27)
	{
		clrscr();
		gotoxy(22,4);
		printf ("MODEL 202 Data Acquisition System");
		gotoxy(34,6);
		printf ("Main Menu");
		gotoxy(20,8);
		printf ("1) Baud rate          %4d",bauds[M202.baud]);
		gotoxy(20,10);
		printf ("2) Serial port        COM%d",M202.comPort+1);
		gotoxy(20,12);
		printf ("3) Input buffer     %6d bytes",M202.RXQUEUESIZE);
		gotoxy(20,14);
		printf ("4) Polled Mode Operation");
		gotoxy(20,16);
		printf ("5) Scanning Mode Operation");
		gotoxy(18,18);
		printf ("Esc) Exit program");

		Ch = getch();

		if (Ch == 27)
		{
			goto EXIT_POINT;
		}

		if (Ch == '1')
		{
			if (M202.baud++ == 5)
			{
				M202.baud = 0;
			}
		}

		if (Ch == '2')
		{
			if (M202.comPort++ == 3)
			{
				M202.comPort = 0;
			}
		}

		if (Ch == '3')
		{
			clrscr();
			SetWin32CursorOn();
			gotoxy (14,12);
			printf("(enter between 11 and 32767)");
			gotoxy(15,10);
			printf("Enter size of input buffer  ");
			#ifdef WIN32
			getch();			
			#endif
			fgets(tmpbuf,80,stdin);
			sscanf(tmpbuf,"%d",&M202.RXQUEUESIZE);

			if (M202.RXQUEUESIZE < 11)
			{
				M202.RXQUEUESIZE = 11;
			}

			SetWin32CursorOff();
		}

		if (Ch == '4')
		{
			M202.sleeping = 0;
			clrscr();
			gotoxy(30,12);
			printf("Signing on...");

			if (!SignOn())
			{
				gotoxy(16,14);
				printf ("unable to sign on.  Press any key to continue");
				getch();
				goto TOP_MENU;
			}

			GetComHandle(&idComDev);	//get handle to comm port

			dacAvolts = 0;
			dacBvolts = 5 / M202.timeBaseCnt;

			gotoxy(20,12);
			printf("Performing system calibration...");

			SysCal();
			GetVer();						//get version


			RemoteAvg();					//set averaging
			SetChanCode();					//set channel and subchannel
			FilterDelay(M202.filter);	//wait filter settling time

			goto POLLED;
		}

		if (Ch == '5')
		{
			clrscr();
			goto GET_SCANS;
		}

	} //while Ch != 27

goto EXIT_POINT;

POLLED:

	clrscr();
	PrintCommandMenu(Ch, localAvg, checkSum);
	while (Ch != 27)						//repeat until esc key pressed or an error
	{
		while (!kbhit() && !M202.standBy)//loop until keyboard hit
		{
			gotoxy(1,p_row++);

			voltage = 0;
			rawCount = 0;

			for (i=0;i<localAvg;i++)
			{
				if(!GetConversion())
				{
				 gotoxy(1,23);
				 printf("get conversion failed, press any key to continue");
				 getch();
				 goto TOP_MENU;
				}

				voltage += M202.voltage;
				rawCount += M202.rawCount;
			}

			M202.voltage = voltage/localAvg;
			M202.rawCount = rawCount/localAvg;

			printf ("   %9ld     %9.3lf",M202.rawCount,M202.voltage);

			if (max < M202.voltage)
			{
				max = M202.voltage;               //update minimum
			}

			if (min > M202.voltage)
			{
				min = M202.voltage;               //update maximum
			}

			StandardDev(&stDv, &rmsBits, &sdTot, &runningAvg, sd, &sdCount);

			if (p_row == 23)
			{
				p_row = 14;
				gotoxy(40,14);
				printf ("Maximum     %9.3lf mv       ", max);
				gotoxy (40,15);
				printf ("Minimum     %9.3lf mv       ", min);
				gotoxy (40,16);
				printf ("Delta       %9.3lf mv       ", fabs(max - min));
				gotoxy (40,17);
				printf ("Average     %9.3lf mv       ", runningAvg);
				gotoxy (40,19);
				printf ("Standard deviation  %9.3lf mv    ", stDv);
				gotoxy (40,20);
				printf ("Effective Resolution  %5.1lf   bits", rmsBits);
				gotoxy (1,14);
			}

		}   //while (!kbhit()  && !M202.standBy)

		Ch = getch();

		if (Ch != 27)
		{
			if (islower(Ch))
			{
				Ch = toupper(Ch);
			}

			if (Ch == 'C' || Ch == 'E' || Ch == 'G' || Ch == 'P' || Ch == 'W')
			{
				stDv=0; rmsBits=0; sdTot = 0; runningAvg=0; sdCount=1;
			}

			DoCommand(Ch, &max, &min, &localAvg, &checkSum, &dacAvolts, &dacBvolts);
		}

	}	//while (Ch != 27)

	goto TOP_MENU;							//end of polled mode example


GET_SCANS:									//start of scanned mode example

	tempCh = M202.channel;				//hold values for current channel and subchannel
	tempSub = M202.subChan;

	if (!ScanMenu())						//setup scanning details
	{
		goto TOP_MENU;
	}

	clrscr();
	gotoxy(30,12);
	printf("Signing on...");

	if (!SignOn())							//signon again with new scanning details
	{
		gotoxy(16,14);
		printf ("unable to sign on.  Press any key to continue");
		getch();
		goto TOP_MENU;
	}

	GetComHandle(&idComDev);		//get handle to comm port

	gotoxy(20,12);
	printf("Performing system calibration...");

	SysCal();
	RemoteAvg();

	clrscr();

	logging = 0;

	gotoxy(20,13);
	printf("Enter name for disk file,");
	gotoxy(20,15);
	printf("or just enter for no file ");
	getch();    
	gets(fileName);

	if (strlen(fileName))
	{
		logging = 1;
	}

	if(logging)
	{
		if ((out = fopen(fileName, "at"))== NULL)
		{
			gotoxy(20,19);
			printf("Could not open/create file\n");
			goto END_SCANS;
		}
	}

	M202.numChannels = 0;

	for (n= 0;n<=5;n++)					//initialize control code array
	{
		cc[n] = (short)(fmod((double)M202.chan[n],16) - (M202.chan[n]>>4) + 1);
		M202.numChannels += cc[n];		//figure total number of channels/scan
	}

	clrscr();

	scanCnt = 0;

	if (M202.tScan == 0)
	{
		ccode = M202.subChan + 3;		//setup location vars for display of
		n = M202.channel * 12 + 4;		//single channel voltages
		SetChanCode();						//set control code for single channel scanning
	}

	StartScanning();  					//Start scanning using selected scan type

	clrscr();
   gotoxy(1, 1);
	printf("CC    chan 0      chan 1       chan 2    ");
	printf(" chan 3      chan 4      chan 5\n\n");

	for(i=0;i<=15;i++)
	{
		printf("%d\n",i);
	}

	gotoxy(2,25);
	printf("Wait               Press any key to quit    ");
	printf("Scan interval %10.3lf secs",M202.scanInterval);

SCANSTATUS:

  while(!kbhit())							//while no keystroke
  {
		receiveError = GetOneScan();	//get one scan from comm

		//If performing pass through commands while scanning, then
		//may be necessary to add as much as .1 seconds to the minimum
		//scan interval to avoid a scanning error.

		if (receiveError != 0)
		{
			gotoxy(2,25);
			printf("SCAN # %ld", ++scanCnt);

			if(M202.tScan == 0)
			{
				gotoxy(n,ccode);
				Gconv();						//get voltage
				printf("%9.3lf", M202.voltage);
				if (logging)
				{
					fprintf(out,"%9.3lf  ", M202.voltage);
				}

				if (logging)
				{
					fprintf(out,"\n");
				}

				goto SCANSTATUS;
			}

			if(M202.tScan == 2)
			{
				gotoxy(2,23);
				printf("Offset cal ");
				Gconv();						//get voltage
				printf("   %9.3lf", M202.voltage);

				if (logging)
				{
					fprintf(out,"%9.3lf  ", M202.voltage);
				}

				gotoxy(27,23);
				printf("Full scale cal ");
				Gconv();						//get voltage
				printf("   %9.3lf", M202.voltage);

				if (logging)
				{
					fprintf(out,"%9.3lf  ", M202.voltage);
				}
			}

			for(n = 0; n <= 5; n++)				//display channel voltages
			{
				startCC = (int)(M202.chan[n] / 16);
				endCC = cc[n] + startCC - 1;

				for(ccode=startCC;ccode<=endCC;ccode++)
				{
					gotoxy((n * 12) + 5,(ccode + 3));
					Gconv();					//get voltage
					printf("%9.3lf", M202.voltage);

					if (logging)
					{
						fprintf(out,"%9.3lf  ", M202.voltage);
					}
				}
			}

			if (logging)
			{
				fprintf(out,"\n");
			}

			if(NewScanBuff[0] != 0x0F)	// should be end of scan token
			{
				printf("End scan framing failure ");
				getch();
				goto END_SCANS;
			}

			RemFromBuffer(1);				//remove end scan token
		}
		else
		{
			gotoxy(2,19);
			if (M202.errorType == 1)
			{
				printf("Start scan framing failure\n");
			}

			if (M202.errorType == 2)
			{
				printf("not enough chars, possible communications error");
			}

			if (M202.errorType == 3)
			{
				printf("buffer overflow");
			}

			if (M202.errorType == 0xA)
			{
				printf("scan rate too fast for this scan type");
			}

			printf("\npress any key to continue");
			getch();

			goto END_SCANS;
		}
	}											//end while !kbhit()

END_SCANS:

	if (logging)
	{
		fclose(out);
	}

	gotoxy(1,25);
	printf("                    Wait                 ");

	while(kbhit())							//empty keyboard buffer
	{
		getch();
	}

	StopScanning();						//Tell the Model 202 to stop scanning

	M202.channel = tempCh;		  		//restore channel and subchannel
	M202.subChan = tempSub;

	goto GET_SCANS;						//end of scanning example

EXIT_POINT:

	CloseDevice();							//close comm port
	FreeLibrary(hLibrary);

	clrscr();
	printf("\nDo you wish to save configuration (y/n)?  ");
	Ch = getch();

	if (Ch == 'Y' || Ch == 'y')
	{
		WriteConfig(&localAvg);
	}

	exit(0);
	return 0;
}






//=============================================================================
//==== GETCHANNEL FUNCTION ====================================================
//=============================================================================
//   Get starting & ending control codes for a scanning channel
short GetChannel(int value)
{
	short startCC=-1, endCC=-1, channel;
	static char  tmpbuf1[80];

	while ((startCC < 0) || (startCC > 15))
	{
		clrscr();
		gotoxy(4,23);
		printf( "Enter an end code smaller than the start code to skip this channel");

		SetWin32CursorOn();
		gotoxy(1,12);
		printf("Channel number:    %d\n",value);
		printf("Enter starting control code  ");
		getch();			
		tmpbuf1[1] = 0;
		fgets(tmpbuf1,80,stdin);

		if (tmpbuf1[1] >= '0')
		{
			startCC =  (short)((tmpbuf1[0] - '0')*10);
			startCC += (short)(tmpbuf1[1] - '0');
		}
		else
		{
			startCC = (short)(tmpbuf1[0] - '0');
		}
	}

	while ((endCC < 0) || (endCC > 15))
	{
		printf("Enter ending control code  ");

		#ifdef WIN32
		getch();			
		#endif
		tmpbuf1[1] = 0;
		fgets(tmpbuf1,80,stdin);
		SetWin32CursorOff();

		if (tmpbuf1[1] >= '0')
		{
			endCC =  (short)((tmpbuf1[0] - '0')*10);
			endCC += (short)(tmpbuf1[1] - '0');
		}
		else
		{
			endCC = (short)(tmpbuf1[0] - '0');
		}
	}

	if ( startCC > endCC)
	{
		startCC = 1;
		endCC = 0;
	}

	channel = (short)(startCC * 16 + endCC);
	return channel;
}






//=============================================================================
//==== PRINTCOMMANDMENU FUNCTION ==============================================
//=============================================================================
void PrintCommandMenu(int Ch, short localAvg, short checkSum)
{
	int nn;

	gotoxy (10,1);
	printf ("POLLED  MENU   Lawson Labs Model 202   Version=%d\n", M202.version);
	gotoxy (5,3);
	printf ("C) A/D input Channel    %d", M202.channel);
	gotoxy (5,4);
	printf ("E) dacs ");

	if (M202.subChan == 8)
	{
		 printf ("enablEd ");
	}
	else
	{
		 printf ("disablEd");
	}

	gotoxy (5,5);
	printf ("A) remote Averaging     %d", M202.average);
	gotoxy (5,6);
	printf ("L) Local averaging      %d        ", localAvg);

	gotoxy (5,8);
	printf ("G) Gain factor        %3d",M202.gain);

	gotoxy (5,9);
	printf ("R) sample Rate       %6.1lf",M202.rate);

	gotoxy (5,10);
	printf( "B) ");
	if (M202.standBy)
	{
		printf("in standBy mode    ");
	}
	else
	{
		printf("out of standBy mode");
	}

	gotoxy (43,3); printf ("D) Digital inputs ");

	if (Ch == 'D')
	{
		printf ("  %d",M202.lastDigInp);

		if (M202.lastDigInp < 100)
		{
			printf ("  ");
		}

		gotoxy (61,2); printf ("Decimal 76543210\n");
		gotoxy (69,3);

		for (nn = 7;nn != -1; nn--)
		{
			if (M202.lastDigInp&(int)(pow(2, nn)))
			{
			  printf ("1");
			}
			else
			{
			  printf ("0");
			}
		}
	}

	gotoxy (43,4); printf ("U) digital oUtput   ");

	if (Ch == 'U')
	{
		printf ("%d  ",M202.digOutWord);
	}

	gotoxy (43,5); printf ("K) checKsum         ");

	if (Ch == 'K')
	{
		if (checkSum)
		{
			printf ("     OK");
		}
		else
		{
			printf (" not OK");
		}
	}
	else
	{
		printf ("        ");
	}

	gotoxy (43,6);
	printf ("S) System calibration");
	gotoxy (43,7);
	printf ("O) Offset calibration");

	gotoxy (43,8);
	printf ("W) Word length      ");

	if (M202.wordCnt == 3)
	{
		printf("24 bits");
	}
	else
	{
		printf("16 bits");
	}

	gotoxy (43,9);
	printf ("P) Polarity        ");

	if (M202.biPolar)
	{
		printf (" Bipolar");
	}
	else
	{
		printf ("Unipolar");
	}

	gotoxy (43,10);
	printf ("Z) DAC settings");

	gotoxy (7,12); printf ("Counts     Millivolts\n");
	gotoxy (1,24);
	printf (" Press ESC for menu or space to reset max/min                       ");
}






//=============================================================================
//==== STANDARDDEV FUNCTION ===================================================
//=============================================================================
//standard deviation and RMS resolution calculation
void    StandardDev(double *stDv, double *rmsBits, double *sdTot,
						  double *runningAvg, double *sd, int    *sdCount)
{
	int i = 0, nnn,sdGrp=40, bits;
	double tempStDv;

	sd[*sdCount] = M202.rawCount;
	(*sdTot) += M202.rawCount;

	if ((*sdCount) == sdGrp)
	{
		(*stDv) = 0;
		(*sdTot) = (*sdTot) / sdGrp;

		for (nnn = 1; nnn != sdGrp; nnn++)
		{
			(*stDv) = (*stDv) + ((*sdTot) - sd[nnn])*((*sdTot) - sd[nnn]);
		}

		(*stDv) = sqrt((*stDv) / (sdGrp-1));
		tempStDv = (*stDv);

CALCNEXT:

		if (tempStDv >= 1)
		{
			i = i + 1;
			tempStDv = tempStDv / 2;
			goto CALCNEXT;
		}

		if (M202.wordCnt == 3)
		{
			bits = 24;
		}
		else
		{
			bits = 16;
		}

		(*rmsBits) = bits - i;

		if ((tempStDv < .75) && (i != 0))
		{
			(*rmsBits) = (*rmsBits) + .5;
		}

		//*runningAvg = Counts2Volts((long)(*sdTot), M202.wordCnt, M202.biPolar);
		M202.rawCount = (long)*sdTot;  // 6-3 added
		*runningAvg = Counts2Volts();

		//(*stDv) = Counts2Volts((long)(*stDv), M202.wordCnt, M202.biPolar);
		M202.rawCount = (long)*stDv;	// 6-3 added
		*stDv = Counts2Volts();

		if (M202.biPolar)
		{
			(*stDv) += 5000;		//unipolar voltage range
		}

		(*sdTot) = 0; (*sdCount) = 1;
	}
	else
	{
		(*sdCount)++;
	}
}






//=============================================================================
//==== DOCOMMAND FUNCTION =====================================================
//=============================================================================
//perform selected function
void DoCommand(int Ch, double *max, double *min, short *localAvg,
					short *checkSum, double *dacAvolts, double *dacBvolts)
{
	int tempCh=0;
	short tempGain;
	char tmpbuf2[80];

	if (islower(Ch))
	{
		Ch = toupper(Ch);
	}

	gotoxy (1,24);
	printf ("                                                   ");

	if (Ch == 'Z')
	{
		//AnalogOut(M202, dacAvolts, dacBvolts);
		AnalogOut(dacAvolts, dacBvolts);
	}

	if (Ch == 'R')
	{
	//	SelectRate(M202);
		SelectRate();
	}

	if (Ch == 'B')
	{

		if(M202.standBy)
		{
			M202.standBy = 0;
		}
		else
		{
			M202.standBy = 1;
		}

		SendADMode();
	}

	if (Ch == 'G')
	{
		M202.gain = (short)fmod(M202.gain*2,255);
		SendADMode();
	}

	if (Ch == 'P')
	{
		if(M202.biPolar)
		{
			M202.biPolar = 0;
		}
		else
		{
			M202.biPolar = 1;
		}

		SendADMode();
		SysCal();
		SetChanCode();
	}

	if (Ch == 'W')
	{
		if(M202.wordCnt == 2)
		{
			M202.wordCnt = 3;
		}
		else
		{
			M202.wordCnt = 2;
		}

		SendADMode();
	}

	if (Ch == 'A')
	{
		while((tempCh != 27) && (tempCh != 13))
		{
			while (!kbhit())
			{
			  gotoxy (1,24);
			  printf ( "Press + increase, - decrease averaging, Enter to continue ");
			  printf ( "%d              ", M202.average);
			}

			tempCh = getch();
			if (tempCh == '+')
			{
			  M202.average *= 2;
			}

			if (tempCh == '-')
			{
			  M202.average /= 2;
			}

			if (M202.average  < 1)
			{
			  M202.average = 32678;
			}
			else if (M202.average > 32678)
			{
			  M202.average = 1;
			}
		}

		RemoteAvg();
	}

	if (Ch == 'C')
	{
		tempCh = -1;

		while ((tempCh < '0') || (tempCh > '7'))
		{
			gotoxy(1,24);
			printf("Enter channel ");
			tempCh = getch();
		}

		M202.channel = (short)(tempCh - '0');

		SetChanCode();
		FilterDelay(M202.filter);
	}

	if (Ch == 'D')
	{
		GetDigIn();
	}

	if (Ch == 'E')
	{
		if (M202.subChan == 8)
		{
			M202.subChan = 0;
		}
		else
		{
			M202.subChan = 8;
		}

		SetChanCode();
		FilterDelay(M202.filter);
	}

	if (Ch == 'L')
	{
		(*localAvg) = 0;
		while ((*localAvg) < 1)
		{
			SetWin32CursorOn();
			gotoxy(1,24);
			printf("Enter local averaging ");
			#ifdef WIN32
			getch();			/////.new.
			#endif
			fgets(tmpbuf2,80,stdin);
			sscanf(tmpbuf2,"%d",localAvg);
			SetWin32CursorOff();
		}
	}

	if (Ch == 'K')
	{
		(*checkSum) = GetCheckSum();
	}

	if (Ch == 'S')
	{
		tempCh =M202.channel;
		tempGain = M202.gain;
		if (M202.gain != 1)
		{
			M202.gain = 1;
			SendADMode();
		}

		SysCal();

		if (tempGain != 1)
		{
			M202.gain = tempGain;
			SendADMode();
			M202.channel = 7;
			OffsetCal();
		}

		M202.channel=(short)tempCh;
		SetChanCode();

		FilterDelay(M202.filter);
	}

	if (Ch == 'O')
	{
		OffsetCal();
	}

	if (Ch == 'F')
	{
		FullScaleCal();
	}

	if (Ch == 'U')
	{
		M202.digOutWord = -1;

		while ((M202.digOutWord < 0) || (M202.digOutWord > 255))
		{
			SetWin32CursorOn();
			gotoxy(1,24);
			printf ("Enter Output Code ");
			getch();			/////.new.
			fgets(tmpbuf2,80,stdin);
			sscanf(tmpbuf2,"%d",&M202.digOutWord);
			SetWin32CursorOff();
		}

		SetDigOut(M202.digOutWord);
	}

	if (Ch == ' ')
	{
		(*max) = -12000.0;
		(*min) = 12000.0;   //reset max-min
	}

	if(!M202.sleeping)
	{
		PrintCommandMenu(Ch, (*localAvg), (*checkSum));
	}

}






//=============================================================================
//==== SCANMENU FUNCTION ======================================================
//=============================================================================
short ScanMenu()							//displays the scanning menu (returns 1 if 
{												// set to start scanning
	int n, vala;
	double maxTime, minTime;
	short	cc[6], i;
	int Ch;

SCANMENU1:
	clrscr();
	M202.numChannels = 0;

	for (n= 0;n<=5;n++)					//initialize control code array
	{
		cc[n] = (short)(fmod((double)M202.chan[n],16) - (M202.chan[n]>>4) + 1);
		M202.numChannels += cc[n];  //figure total number of channels/scan
	}

	gotoxy(27,1);
	printf("SCANNING  CONFIGURATION");
	gotoxy(14,3);
	printf("CHANNEL      EXTERNAL CONTROL CODE      NUMBER OF");
	gotoxy(54,4);
	printf("DATA POINTS");

	if(M202.tScan == 0)
	{
		M202.channel = (short)(M202.singleChan>>4);
		gotoxy(18,7);
		printf ("%d",M202.channel);
		printf("               %d                 1", M202.subChan);
		gotoxy(15,10);
		printf("   PRESS 0 - 5 FOR CHANNEL");
	}
	else
	{
		gotoxy(29,5);
		printf("FROM           TO        THIS CHANNEL");

		for (n=0;n<=5;n++)
		{
		gotoxy(17,7 + n * 2);
		printf("%d)           ", n);
		printf( "%2d            %2d           %2d",M202.chan[n]>>4, (int)fmod((double)M202.chan[n],16), cc[n]);
		}
	}

	gotoxy(17,19);
	printf("6) Scan Interval  %11.4lf seconds",M202.scanInterval);

	if((M202.gain != 1) && (M202.tScan == 2))
	{
		M202.tScan = 0;    //no cal scan unless gain=1
	}

	gotoxy(17,21);
	printf("7) Scan type: ");

	if (M202.tScan == 0)
	{
		printf ("Single Channel  ");
	}
	else if (M202.tScan == 1)
	{
		printf ("Normal          ");
	}
	else
	{
		printf ("Self-Calibration");
	}

	gotoxy(11,23);
	printf("  Enter) Perform the scan");
	gotoxy(15,25);
	printf("Esc) To continue");

	if(M202.tScan > 0)
	{
		printf("       data points per scan  %d",M202.numChannels);
	}

	Ch = getch();
	vala = Ch -'0';

	if((vala == 0) && (Ch != '0'))
	{
		vala = 10;							//flag invalid keystroke
	}

	if((vala >= 0) && (vala <= 5))
	{
		if (M202.tScan == 0)
		{
			clrscr();
			gotoxy(10,12);
			printf("Channel number:    %d",vala);
			M202.channel = (short)vala;
			M202.singleChan = (short)((vala<<4) +  M202.subChan);
		}
		else
		{
			M202.chan[vala] = GetChannel(vala);
		}
	}

	if(vala == 6)
	{
		CalcScanTime();
	}

	if(vala == 7)
	{

		if (M202.tScan == 0)
		{
			M202.tScan = 1;
		}
		else if (M202.tScan == 1)
		{
			M202.tScan = 2;
		}
		else
		{
			M202.tScan = 0;
		}

		if (M202.gain != 1 && M202.tScan == 2)
		{
			M202.tScan = 0;
		}
	}

	if(Ch == 13)
	{
		if(M202.numChannels == 0)
		{
			printf("You must enter control codes first, press any key to continue");
			getch();
			goto SCANMENU1;
		}

		i = CheckScanTime(&maxTime, &minTime);

		if (i==2)
		{
			printf("Reduced averaging to %d- Press any key to continue",M202.average);
			getch();
		}
		else if(!i)
		{
			clrscr();
			gotoxy(10,15);
			printf("Scan time out of limits, press any key to continue");
			getch();
			CalcScanTime();
		}

		return 1;
	}

	if(Ch == 27)
	{
		 return 0;
	}

	goto SCANMENU1;
}






//=============================================================================
//==== CALCSCANTIME FUNCTION ==================================================
//=============================================================================
/****************************************************************************
Because all aspects of the scanning function of the Model 202 are programmable,
it can be difficult to determine what the optimal settings are for any
particular task. Also, if the A/D is not performing as intended, it can be
hard to determine the cause. An overview of how to set up the 202 from a
programmer's perspective follows.

The A/D is constantly performing conversions at DATARATE. This rate is set in
the mode registers of the A/D chip itself. Slower DATARATEs provide lower
noise, higher DATARATEs allow higher frequencies to be seen, and allow more
data points to be taken in the same time period.

For higher frequency applications the DATARATE should be set for the
appropriate low-pass filter cutoff frequency. The cutoff frequency is
approximately one quarter the DATARATE.

For DC and very low frequency applications, you would normally select the
lowest possible DATARATE. That lowest rate is determined by all the
programmable scanning variables - scan type, the number of channels scanned,
averaging, word length and BAUD rate. Even though the DATARATE is actually
sent to the A/D before the rest of the scanning details during the sign-on
process, it should be calculated last. Details for Model 202 follow:


  M202.baud           = 0 for 9600, 1 for 4800, etc.
  M202.numChannels    = number of channels to scan
  M202.average        = number of conversions to average
								(1, 2, 4, 8, 16, 32 etc)
  M202.wordCnt        = number of bytes in conversion ( 2 or 3)

Here, we have solved for the minimum sample rate given the scan interval:

  minSampleRate = (M202.average + 2) / ((M202.scanInterval - (M202.wordCnt *
				 .002333) * 2 ^ M202.baud) / M202.numChannels - .03);

A 5 percent margin should provide comfort. The following line would take
care of that:

  M202.rate = 1.05 * minSampleRate;
****************************************************************************/
short CalcScanTime()	//select the scan interval
{
	double minTime, maxTime;
	char tmpbuf4[80];
	short i;

	clrscr();

CALCSCANTIME1:

	if(M202.numChannels == 0)
	{
		printf("You must enter control codes first, press any key to continue");
		getch();
		return 0;
	}

	i = CheckScanTime(&maxTime, &minTime);

	if (i==2)
	{
		printf("Reduced averaging to %d- Press any key to continue",M202.average);
		getch();
	}

	SetWin32CursorOn();
	gotoxy(10,10);
	printf("Enter scan time ");
	printf("%10.4lf  - ", minTime);
	printf( "%12.4lf  seconds  ", maxTime);
	getch();			/////.new.
	fgets(tmpbuf4,80,stdin);
	sscanf(tmpbuf4,"%lf",&M202.scanInterval);
	SetWin32CursorOff();

	i = CheckScanTime(&maxTime, &minTime);

	if (i==2)
	{
		printf("Reduced averaging to %d- Press any key to continue",M202.average);
		getch();
	}
	else if(!i)
	{
		clrscr();
		gotoxy(10,15);
		printf("Scan time out of limits, press any key to continue");
		getch();
		goto CALCSCANTIME1;
	}

	return 1;
}






//=============================================================================
//==== SELECTRATE FUNCTION ====================================================
//=============================================================================
void SelectRate()    //select the sampling rate for the A/D
{
	char tmpbuf5[80];

	SetWin32CursorOn();
	gotoxy(1,24);
	printf("            Enter sample rate between 10 and 1027  ");
	getch();			/////.new.
	fgets(tmpbuf5,80,stdin);
	sscanf(tmpbuf5,"%f",&M202.rate);
	SetWin32CursorOff();

	if (M202.rate > 1027)
	{
		M202.rate = 1027;
	}
	else if (M202.rate < 10)
	{
		M202.rate = 10;
	}

	SendADMode();
	SysCal();
	SetChanCode();

	gotoxy(1,24);
	printf("                                                          ");
}






//=============================================================================
//==== READCONFIG FUNCTION ====================================================
//=============================================================================
//read 202EWIN.CFG file from disk in current directory
short ReadConfig(short *localAvg)	
{
	char tmpbuf6[80];
	FILE *rCfg;

	if ((rCfg = fopen("202ewin.cfg", "rt")) != NULL)
	{
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",&M202.TXQUEUESIZE);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",&M202.RXQUEUESIZE);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",&M202.baud);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",&M202.comPort);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%lf",&M202.scanInterval);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",&M202.numChannels);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",&M202.average);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",&M202.tScan);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",&M202.chan[0]);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",&M202.chan[1]);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",&M202.chan[2]);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",&M202.chan[3]);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",&M202.chan[4]);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",&M202.chan[5]);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",&M202.singleChan);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",&M202.channel);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",&M202.subChan);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",&M202.wordCnt);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",&M202.biPolar);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",&M202.filter);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",&M202.gain);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%f",&M202.rate);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",&M202.modeRegLo);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",&M202.modeRegMid);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",&M202.modeRegHi);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",&M202.timeBaseCnt);
		fgets(tmpbuf6,80,rCfg);
		sscanf(tmpbuf6,"%d",localAvg);
		fclose(rCfg);
		return 1;
	}
	else
	{
		M202.TXQUEUESIZE = 1;
		M202.RXQUEUESIZE = 1024;
		M202.baud = 0;
		M202.comPort = 0;
		M202.filter = 2;
		M202.gain = 1;
		M202.rate = 10;
		M202.wordCnt = 3;
		M202.biPolar = 1;
		M202.average = 1;
		M202.scanInterval = 2;
		M202.numChannels = 6;
		M202.chan[0]= 0;
		M202.chan[1]= 0;
		M202.chan[2]= 0;
		M202.chan[3]= 0;
		M202.chan[4]= 0;
		M202.chan[5]= 0;
		M202.singleChan = 0;
		M202.tScan = 1;
		M202.channel = 0;
		M202.subChan = 0;
		M202.timeBaseCnt = 10000;
		(*localAvg) = 1;
		return 0;
	}
}






//=============================================================================
//==== WRITECONFIG FUNCTION ===================================================
//=============================================================================
short WriteConfig(short *localAvg)
{
	FILE *wCfg;

	if ((wCfg = fopen("202ewin.cfg", "wt")) != NULL)
	{
		fprintf(wCfg,"%d\n",M202.TXQUEUESIZE);
		fprintf(wCfg,"%d\n",M202.RXQUEUESIZE);
		fprintf(wCfg,"%d\n",M202.baud);
		fprintf(wCfg,"%d\n",M202.comPort);
		fprintf(wCfg,"%lf\n",M202.scanInterval);
		fprintf(wCfg,"%d\n",M202.numChannels);
		fprintf(wCfg,"%d\n",M202.average);
		fprintf(wCfg,"%d\n",M202.tScan);
		fprintf(wCfg,"%d\n",M202.chan[0]);
		fprintf(wCfg,"%d\n",M202.chan[1]);
		fprintf(wCfg,"%d\n",M202.chan[2]);
		fprintf(wCfg,"%d\n",M202.chan[3]);
		fprintf(wCfg,"%d\n",M202.chan[4]);
		fprintf(wCfg,"%d\n",M202.chan[5]);
		fprintf(wCfg,"%d\n",M202.singleChan);
		fprintf(wCfg,"%d\n",M202.channel);
		fprintf(wCfg,"%d\n",M202.subChan);
		fprintf(wCfg,"%d\n",M202.wordCnt);
		fprintf(wCfg,"%d\n",M202.biPolar);
		fprintf(wCfg,"%d\n",M202.filter);
		fprintf(wCfg,"%d\n",M202.gain);
		fprintf(wCfg,"%f\n",M202.rate);
		fprintf(wCfg,"%d\n",M202.modeRegLo);
		fprintf(wCfg,"%d\n",M202.modeRegMid);
		fprintf(wCfg,"%d\n",M202.modeRegHi);
		fprintf(wCfg,"%d\n",M202.timeBaseCnt);
		fprintf(wCfg,"%d\n",(*localAvg));
		fclose(wCfg);
		return 1;
	}

	return 0;
}






//=============================================================================
//==== ANALOGOUT FUNCTION =====================================================
//=============================================================================
void AnalogOut(double *dacAvolts, double *dacBvolts)
{
	int Ch;
	int countsPerVolt, cntrCount, cntPort;
	double voltage;

	countsPerVolt = M202.timeBaseCnt / 5;  // counts for 1 volt

ANALOGOUT:											//set analog output voltage

	clrscr();
	gotoxy (30,10);
	printf("DAC A          DAC B");
	gotoxy(27,12);
	printf("%9.3lf      %9.3lf", (*dacAvolts)*1000,(*dacBvolts)*1000);
	gotoxy(5,25);
	printf("1 for DAC A, 2 for DAC B, ESC to return");
	printf("    Resolution  1 /%d", M202.timeBaseCnt);

	Ch = 0;
	while (Ch < '1' || Ch > '2')
	{
		Ch = getch();

		if (Ch == 27)
		{
			goto EXITANALOGOUT;
		}
	}

	voltage = -1;

	clrscr();
	gotoxy(20,10);
	printf("Enter output voltage 0 - 5000mv  ");
	getch();

	while (voltage < 0 || voltage > 5000)
	{
		clrscr();
		gotoxy(20,10);
		printf("Enter output voltage 0 - 5000mv  ");
		scanf("%lf",&voltage);
	}


	cntrCount = (int)(((voltage/1000) * countsPerVolt));	//calculate counts

	//the dac A is inverted with respect to dac B
	if( Ch == '1')
	{
		cntrCount = M202.timeBaseCnt - cntrCount;
	}

	//don't exceed the max count
	if(cntrCount > M202.timeBaseCnt)
	{
		cntrCount = M202.timeBaseCnt;
	}

	if (cntrCount < 1)
	{
		cntrCount = 1;									//0 is illegal count
	}

	if(Ch == '1')
	{
		cntPort = 1;									//set counter address
		(*dacAvolts) =(double)(M202.timeBaseCnt - cntrCount);
		(*dacAvolts) /= (double)countsPerVolt; //set last voltage
	}
	else
	{
		cntPort = 2;									//set counter address
		(*dacBvolts) = (double)cntrCount;
		(*dacBvolts) /= (double)countsPerVolt;	//set last voltage
	}

	WriteCntr(cntPort, cntrCount);     			//set the voltage

	goto ANALOGOUT;

EXITANALOGOUT:
	clrscr();
}






//=============================================================================
//==== SETWIN32CURSORON FUNCTION ==============================================
//=============================================================================
void SetWin32CursorOn(void)
{
	ConsoleCursorInfo.bVisible = TRUE;
	SetConsoleCursorInfo(hOutCon, &ConsoleCursorInfo);
}






//=============================================================================
//==== SETWIN32CURSOROFF FUNCTION =============================================
//=============================================================================
void SetWin32CursorOff(void)
{
	ConsoleCursorInfo.bVisible = FALSE;
	SetConsoleCursorInfo(hOutCon, &ConsoleCursorInfo);
}






//=============================================================================
//==== UNLOADLIBRARITES FUNCTION ==============================================
//=============================================================================
BOOLEAN
LoadLibraries()
{
	hLibM201 = LoadLibrary ("NT_m201.dll");
	if(!hLibM201)
	{
		MessageBox(0, "Error loading NT_m201.DLL", "-- error", MB_OK);
		return FALSE;
	}
	return TRUE;
}






//=============================================================================
//==== LOADLIBRARIES FUNCTION =================================================
//=============================================================================
BOOLEAN
UnloadLibraries()
{
	FreeLibrary(hLibM201);
	hLibM201 = NULL;
	return TRUE;
}






//=============================================================================
//==== CHECKLIBFUNCS FUNCTION =================================================
//=============================================================================
BOOLEAN
CheckLibFuncs()
{
	BOOLEAN Status = TRUE;

	SetPtrs = (DLL_SET_PTRS)GetProcAddress(hLibM201, "SetPtrs");
	if(!SetPtrs)
	{
		MessageBox(0, "failed to find function:\n     SetPtrs(...)"
				 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	SignOn = (DLL_SIGN_ON)GetProcAddress(hLibM201, "SignOn");
	if(!SignOn)
	{
		MessageBox(0, "failed to find function:\n     SignOn()"
				 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	RemoteAvg = (DLL_REMOTE_AVG)GetProcAddress(hLibM201, "RemoteAvg");
	if(!RemoteAvg)
	{
		MessageBox(0, "failed to find function:\n     RemoteAvg(...)"
				 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	Counts2Volts = (DLL_COUNTS_2_VOLTS)GetProcAddress(hLibM201, "Counts2Volts");
	if(!Counts2Volts)
	{
		MessageBox(0, "failed to find function:\n     Counts2Volts(...)"
			 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	GetDigIn = (DLL_GET_DIG_IN)GetProcAddress(hLibM201, "GetDigIn");
	if(!GetDigIn)
	{
		MessageBox(0, "failed to find function:\n     GetDigIn(...)"
			 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	GetVer = (DLL_GET_VER)GetProcAddress(hLibM201, "GetVer");
	if(!GetVer)
	{
		MessageBox(0, "failed to find function:\n     GetVer(...)"
			 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	SetDigOut = (DLL_SET_DIG_OUT)GetProcAddress(hLibM201, "SetDigOut");
	if(!SetDigOut)
	{
		MessageBox(0, "failed to find function:\n     SetDigOut(...)"
				 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	FullScaleCal = (DLL_FULL_SCALE_CAL)GetProcAddress(hLibM201, "FullScaleCal");
	if(!FullScaleCal)
	{
		MessageBox(0, "failed to find function:\n     FullScaleCal(...)"
				 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	OffsetCal = (DLL_OFFSET_CAL)GetProcAddress(hLibM201, "OffsetCal");
	if(!OffsetCal)
	{
		MessageBox(0, "failed to find function:\n     OffsetCal(...)"
				 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	SysCal = (DLL_SYS_CAL)GetProcAddress(hLibM201, "SysCal");
	if(!SysCal)
	{
		MessageBox(0, "failed to find function:\n     SysCal(...)"
				 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	GetConversion = (DLL_GET_CONVERSION)GetProcAddress(hLibM201, "GetConversion");
	if(!GetConversion)
	{
		MessageBox(0, "failed to find function:\n     GetConversion(...)"
				 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	SetChanCode = (DLL_SET_CHAN_CODE)GetProcAddress(hLibM201, "SetChanCode");
	if(!SetChanCode)
	{
		MessageBox(0, "failed to find function:\n     SetChanCode(...)"
				 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	StartScanning = (DLL_START_SCANNING)GetProcAddress(hLibM201, "StartScanning");
	if(!StartScanning)
	{
		MessageBox(0, "failed to find function:\n     StartScanning(...)"
				 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	GetOneScan = (DLL_GET_ONE_SCAN)GetProcAddress(hLibM201, "GetOneScan");
	if(!GetOneScan)
	{
		MessageBox(0, "failed to find function:\n     GetOneScan(...)"
				 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	StopScanning = (DLL_STOP_SCANNING)GetProcAddress(hLibM201, "StopScanning");
	if(!StopScanning)
	{
		MessageBox(0, "failed to find function:\n     StopScanning(...)"
				 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	Gconv = (DLL_GCONV)GetProcAddress(hLibM201, "Gconv");
	if(!Gconv)
	{
		MessageBox(0, "failed to find function:\n     Gconv(...)"
				 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	RemFromBuffer = (DLL_REMOVE_FROM_BUFFER)GetProcAddress(hLibM201, "RemFromBuffer");
	if(!RemFromBuffer)
	{
		MessageBox(0, "failed to find function:\n     RemFromBuffer(...)"
				 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	SetFilter = (DLL_SET_FILTER)GetProcAddress(hLibM201, "SetFilter");
	if(!SetFilter)
	{
		MessageBox(0, "failed to find function:\n     SetFilter(...)"
				 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	SendADMode = (DLL_SEND_AD_MODE)GetProcAddress(hLibM201, "SendADMode");
	if(!SendADMode)
	{
		MessageBox(0, "failed to find function:\n     SendADMode(...)"
				 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	GetCheckSum = (DLL_GET_CHECK_SUM)GetProcAddress(hLibM201, "GetCheckSum");
	if(!GetCheckSum)
	{
		MessageBox(0, "failed to find function:\n     GetCheckSum(...)"
				 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	CloseDevice = (DLL_CLOSE_DEVICE)GetProcAddress(hLibM201, "CloseDevice");
	if(!CloseDevice)
	{
		MessageBox(0, "failed to find function:\n     CloseDevice(...)"
				 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	GotoSleep = (DLL_GOTO_SLEEP)GetProcAddress(hLibM201, "GotoSleep");
	if(!GotoSleep)
	{
		MessageBox(0, "failed to find function:\n     GotoSleep(...)"
				 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	WriteCntr = (DLL_WRITE_CNTR)GetProcAddress(hLibM201, "WriteCntr");
	if(!WriteCntr)
	{
		MessageBox(0, "failed to find function:\n     WriteCntr(...)"
				 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}

	FilterDelay = (DLL_FILTER_DELAY)GetProcAddress(hLibM201, "FilterDelay");
	if(!FilterDelay)
	{
		MessageBox(0, "failed to find function:\n     FilterDelay(...)"
				 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	CheckScanTime = (DLL_CHECK_SCAN_TIME)GetProcAddress(hLibM201, "CheckScanTime");
	if(!CheckScanTime)
	{
		MessageBox(0, "failed to find function:\n     CheckScanTime(...)"
				 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	GetComHandle = (DLL_GET_COM_HANDLE)GetProcAddress(hLibM201, "GetComHandle");
	if(!GetComHandle)
	{
		MessageBox(0, "failed to find function:\n     GetComHandle(...)"
				 "\nin M201_98.DLL\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
		return FALSE;
	}
	return Status;
}



